<mat-tab-group [selectedIndex]="tabSelected" (selectedTabChange)="tabChanged($event)">
  <mat-tab label="Dados da unidade">
    <mat-card>
      <mat-card-title>Alterar {{unidade.tipoUnidade}} - {{unidade.unidadeNome}}</mat-card-title>
      <mat-card-content>
        <div class="container-fluid">
          <form (ngSubmit)="unidadeForm.form.valid && onSubmit()" #unidadeForm="ngForm">
            <div class="form-row">
              <div class="form-group col-md-2">
                <mat-form-field>
                  <input matInput placeholder="Código" id="codigo"
                      [(ngModel)]="unidade.unidadeId" name="codigo" #codigo="ngModel"
                      readonly="true" required>
                  <mat-error *ngIf="codigo.invalid || codigo.pristine">O Código é obrigatório!</mat-error>
                </mat-form-field>
              </div>

              <div class="form-group col-md-3">
                <mat-form-field>
                  <mat-select id="tipo" placeholder="Tipo Unidade" required [(ngModel)]="unidade.tipoUnidade" name="tipo" #tipo="ngModel" (ngModelChange)="carregarUnidadesSuperiores(unidade.tipoUnidade)">
                    <mat-option>Selecione</mat-option>
                    <mat-option *ngFor="let tipoUnidade of tipoUnidades" [value]="tipoUnidade">{{tipoUnidade}}</mat-option>
                  </mat-select>
                  <mat-error *ngIf="tipo.invalid || tipo.pristine">O Tipo de Unidade é obrigatório!</mat-error>
                </mat-form-field>
              </div>
              <div class="form-group col-md-7">
                <mat-form-field>
                  <input matInput placeholder="Nome" id="nome"
                      [(ngModel)]="unidade.unidadeNome" name="nome" #nome="ngModel" required>
                    <mat-error *ngIf="nome.invalid || nome.pristine">O Nome é obrigatório!</mat-error>
                </mat-form-field>
              </div>
            </div>

            <div class="form-row">
              <div class="form-group col-md-3">
                <mat-form-field>
                  <mat-select id="tipoLogradouro" placeholder="Tipo Logradouro" required [(ngModel)]="unidade.endereco.tipoLogradouro" name="tipoLogradouro" #tipoLogradouro="ngModel">
                    <mat-option>Selecione</mat-option>
                    <mat-option *ngFor="let tipoLogradouro of tipoLogradouros" [value]="tipoLogradouro">{{tipoLogradouro}}</mat-option>
                  </mat-select>
                  <mat-error *ngIf="tipoLogradouro.invalid || tipoLogradouro.pristine">O Tipo Logradouro é obrigatório!</mat-error>
                </mat-form-field>
              </div>

              <div class="form-group col-md-6">
                <mat-form-field>
                  <input matInput placeholder="Logradouro" id="logradouro"
                      [(ngModel)]="unidade.endereco.logradouro" name="logradouro" #logradouro="ngModel" required>
                    <mat-error *ngIf="logradouro.invalid || logradouro.pristine">O Logradouro é obrigatório!</mat-error>
                </mat-form-field>
              </div>

              <div class="form-group col-md-3">
                <mat-form-field>
                  <input matInput placeholder="Número" id="numeroLogradouro"
                      [(ngModel)]="unidade.endereco.numero" name="numeroLogradouro" #numeroLogradouro="ngModel" required>
                  <mat-error *ngIf="numeroLogradouro.invalid || numeroLogradouro.pristine">O Número do Logradouro é obrigatório!</mat-error>
                </mat-form-field>
              </div>
            </div>

            <div class="form-row">
              <div class="form-group col-md-3">
                <mat-form-field>
                  <input matInput placeholder="Complemento" id="complemento"
                      [(ngModel)]="unidade.endereco.complemento" name="complemento" #complemento="ngModel">
                </mat-form-field>
              </div>

              <div class="form-group col-md-3">
                <mat-form-field>
                  <input matInput placeholder="Bairro" id="bairro" required
                      [(ngModel)]="unidade.endereco.bairro" name="bairro" #bairro="ngModel">
                  <mat-error *ngIf="bairro.invalid || bairro.pristine">O Bairro é obrigatório!</mat-error>
                </mat-form-field>
              </div>
              <div class="form-group col-md-6">
                <mat-form-field>
                  <input matInput placeholder="Ponto Referência" id="referenciaEndereco"
                      [(ngModel)]="unidade.endereco.referenciaEndereco" name="referenciaEndereco" #referenciaEndereco="ngModel">
                </mat-form-field>
              </div>
          </div>

          <div class="form-row">
            <div class="form-group col-md-3">
              <mat-form-field>
                <mat-select id="uf" required [(ngModel)]="unidade.endereco.uf.ufSigla" placeholder="Estado" name="uf" #uf="ngModel" (ngModelChange)="carregarCidades(unidade.endereco.uf.ufSigla)">
                  <mat-option>Selecione</mat-option>
                  <mat-option *ngFor="let estado of estados" [value]="estado.ufSigla">{{estado.ufNome}}</mat-option>
                </mat-select>
                <mat-error *ngIf="uf.invalid || uf.pristine">O Estado é obrigatório!</mat-error>
              </mat-form-field>
            </div>

            <div class="form-group col-md-3">
              <mat-form-field>
                <mat-select id="cidade" required [(ngModel)]="unidade.endereco.cidade.cidadeId" placeholder="Cidade" name="cidade" #cidade="ngModel">
                  <mat-option>Selecione</mat-option>
                  <mat-option *ngFor="let cidade of cidades" [value]="cidade.cidadeId">{{cidade.cidadeNome}}</mat-option>
                </mat-select>
                <mat-error *ngIf="cidade.invalid || cidade.pristine">A Cidade é obrigatória!</mat-error>
              </mat-form-field>
            </div>

            <div class="form-group col-md-2">
              <mat-form-field>
                <input matInput placeholder="CEP" id="cep" mask="00000-000" [showMaskTyped]="true" required
                    [(ngModel)]="unidade.endereco.cep" name="cep" #cep="ngModel">
                <mat-error *ngIf="cep.invalid || cep.pristine">O CEP é obrigatório!</mat-error>
              </mat-form-field>
            </div>

            <div class="form-group col-md-4">
              <mat-form-field>
                <input matInput type="email" placeholder="E-mail" id="emailResponsavel" required email
                    [(ngModel)]="unidade.email" name="emailResponsavel" #emailResponsavel="ngModel">
                <mat-error *ngIf="emailResponsavel.invalid && emailResponsavel.errors.required">O E-mail é obrigatório!</mat-error>
                <mat-error *ngIf="emailResponsavel.invalid && emailResponsavel.errors.email">O E-mail informado é inválido!</mat-error>
              </mat-form-field>
            </div>
          </div>

          <div class="form-row">
            <div class="form-group col-md-3">
              <mat-form-field>
                <input matInput placeholder="Dia Reunião" id="diaReuniao" required
                    [(ngModel)]="unidade.reuniao.diaSemana" name="diaReuniao" #diaReuniao="ngModel">
                <mat-error *ngIf="diaReuniao.invalid || diaReuniao.pristine">O Dia Reunião é obrigatório!</mat-error>
              </mat-form-field>
            </div>
            <div class="form-group col-md-2">
              <mat-form-field>
                <input matInput placeholder="Hora Reunião" id="horaReuniao" mask="Hh:m0" [showMaskTyped]="true" required
                    [(ngModel)]="unidade.reuniao.horario" name="horaReuniao" #horaReuniao="ngModel">
                <mat-error *ngIf="horaReuniao.invalid || horaReuniao.pristine">A Hora Reunião é obrigatória!</mat-error>
              </mat-form-field>
            </div>
            <div class="form-group col-md-2">
              <mat-form-field>
                <input matInput ngxPhoneMaskBr placeholder="Telefone" id="telefone" required
                    [(ngModel)]="unidade.telefone" name="telefone" #telefone="ngModel">
                <mat-error *ngIf="telefone.invalid || telefone.pristine">O Telefone é obrigatório!</mat-error>
              </mat-form-field>
            </div>
            <div class="form-group col-md-5">
              <mat-form-field>
                <mat-select id="unidadeSuperior" [(ngModel)]="unidade.unidadeSuperior.unidadeId" placeholder="Unidade Superior" name="unidadeSuperior" #unidadeSuperior="ngModel">
                  <mat-option>Selecione</mat-option>
                  <mat-option *ngFor="let unidade of unidadesSuperiores" [value]="unidade.unidadeId">{{unidade.unidadeNome}}</mat-option>
                </mat-select>
              </mat-form-field>
            </div>
          
          </div>

          <div class="form-row">
            <div class="form-group">
              <mat-card-actions>
                <button type="submit" class="btn btn-primary">Salvar</button>
                <button class="btn btn-light" (click)="voltarConsulta()">voltar</button>
              </mat-card-actions>
            </div>
          </div>
          </form>
        </div>
      </mat-card-content>
    </mat-card>
  </mat-tab>
  <mat-tab label="Membros">
      <mat-card>
        <mat-card-title>Associar Membros ({{unidade.tipoUnidade}} - {{unidade.unidadeNome}})</mat-card-title>
        <mat-card-content>
          <div class="container-fluid">
            <form (ngSubmit)="associarMembroForm.form.valid && onSubmitPesquisar(associarMembroForm)" #associarMembroForm="ngForm">
              <div class="form-row">
                <div class="form-group col-md-6">
                  <mat-form-field>
                    <input matInput placeholder="Nome Membro" id="pesquisaMembro"
                        [(ngModel)]="pesquisaMembroText" name="pesquisaMembro" #pesquisaMembro="ngModel" required>
                      <mat-error *ngIf="pesquisaMembro.invalid || pesquisaMembro.pristine">O Nome Membro é obrigatório!</mat-error>
                  </mat-form-field>
                </div>
                <div class="form-group col-md-4"></div>
                <div class="form-group col-md-2">
                    <button type="submit" class="btn btn-secondary">Buscar</button>
                </div>
              </div>
            

              <div class="form-row" *ngIf="membrosPesquisados">
                  <div class="form-group col-md-12">
                    <table mat-table [dataSource]="membrosPesquisados" matSort class="mat-elevation-z8">
                        <ng-container matColumnDef="numero" sticky>
                          <th mat-header-cell *matHeaderCellDef mat-sort-header> Número </th>
                          <td mat-cell *matCellDef="let element"> {{element.membroId}} </td>
                        </ng-container>
          
                      <ng-container matColumnDef="nome" sticky>
                        <th mat-header-cell *matHeaderCellDef mat-sort-header> Nome </th>
                        <td mat-cell *matCellDef="let element"> {{element.nome}} </td>
                      </ng-container>
          
                      <ng-container matColumnDef="email">
                        <th mat-header-cell *matHeaderCellDef mat-sort-header> E-mail </th>
                        <td mat-cell *matCellDef="let element"> {{element.email}} </td>
                      </ng-container>
          
                      <ng-container matColumnDef="telefone">
                        <th mat-header-cell *matHeaderCellDef mat-sort-header> Telefone </th>
                        <td mat-cell *matCellDef="let element">
                            {{element.telefone | fone }}
                        </td>
                      </ng-container>
                      
                      <ng-container matColumnDef="situacaoMembro" stickyEnd>
                        <th mat-header-cell *matHeaderCellDef mat-sort-header> Situação Membro </th>
                        <td mat-cell *matCellDef="let element"> {{element.situacaoMembro}} </td>
                      </ng-container>
          
                      <ng-container matColumnDef="acoes">
                        <th mat-header-cell *matHeaderCellDef> Ações </th>
                        <td mat-cell *matCellDef="let element">
                            <mat-icon *ngIf="!element.estaAssociado" (click)="associarMembro(element, associarMembroForm)" class="icon-link" title="Associar membro à unidade">input</mat-icon>
                        </td>
                      </ng-container>
          
                      <tr mat-header-row *matHeaderRowDef="displayedColumnsPesquisados; sticky: true;"></tr>
                      <tr mat-row *matRowDef="let row; let even = even; columns: displayedColumnsPesquisados;" [ngClass]="{gray: even}"></tr>
                    </table>
                  </div>
                </div>

              <div class="form-row">
                <div class="form-group col-md-12">
                    <h4>Associados à unidade:</h4>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group col-md-12">
                  <table mat-table [dataSource]="membrosAssociados" matSort class="mat-elevation-z8">
                      <ng-container matColumnDef="numero" sticky>
                        <th mat-header-cell *matHeaderCellDef mat-sort-header> Número </th>
                        <td mat-cell *matCellDef="let element"> {{element.membroId}} </td>
                      </ng-container>
        
                    <ng-container matColumnDef="nome" sticky>
                      <th mat-header-cell *matHeaderCellDef mat-sort-header> Nome </th>
                      <td mat-cell *matCellDef="let element"> {{element.nome}} </td>
                    </ng-container>
        
                    <ng-container matColumnDef="email">
                      <th mat-header-cell *matHeaderCellDef mat-sort-header> E-mail </th>
                      <td mat-cell *matCellDef="let element"> {{element.email}} </td>
                    </ng-container>
        
                    <ng-container matColumnDef="telefone">
                      <th mat-header-cell *matHeaderCellDef mat-sort-header> Telefone </th>
                      <td mat-cell *matCellDef="let element">
                          {{element.telefone | fone }}
                      </td>
                    </ng-container>
                    
                    <ng-container matColumnDef="situacaoMembro" stickyEnd>
                      <th mat-header-cell *matHeaderCellDef mat-sort-header> Situação Membro </th>
                      <td mat-cell *matCellDef="let element"> {{element.situacaoMembro}} </td>
                    </ng-container>
        
                    <ng-container matColumnDef="acoes">
                      <th mat-header-cell *matHeaderCellDef> Ações </th>
                      <td mat-cell *matCellDef="let element">
                          <mat-icon (click)="desassociarMembro(element, associarMembroForm)" class="icon-link" title="Desassociar membro da unidade">backspace</mat-icon>
                      </td>
                    </ng-container>
        
                    <tr mat-header-row *matHeaderRowDef="displayedColumnsAssociados; sticky: true;"></tr>
                    <tr mat-row *matRowDef="let row; let even = even; columns: displayedColumnsAssociados;" [ngClass]="{gray: even}"></tr>
                  </table>
                </div>
              </div>
            </form>
          </div>

          
        </mat-card-content>
      </mat-card>
  </mat-tab>
</mat-tab-group>